#include "ctrlfd.h"

class l2tp_session_t;
class l2tp_packet_t;
class l2tp_monitor_t : public ctrlfd_die_listener {
public:
	ctrlfd_t *m_cfd;
	const char *m_user;
	l2tp_session_t *m_session;

	l2tp_monitor_t(ctrlfd_t *cfd, const char *user);
	virtual void ctrlfd_die_notification(ctrlfd_t *cfd);
	virtual ~l2tp_monitor_t();

	void try_monitor(l2tp_session_t *session, const char *user);
	void remove_session(l2tp_session_t *session);

	void monitor_l2tp_control_pkt(l2tp_packet_t *pkt, const char *rxtx);
	void monitor_l2tp_data_pkt(u8 *data, unsigned len, const char *rxtx);
};

void l2tpctl_monitor(ctrlfd_t *cfd, const char *user);
void try_l2tp_monitor(l2tp_session_t *session, const char *user);

