#include <net/if.h>
#include <linux/if_tun.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

void dump_buf(unsigned char *buf, int len)
{
	int i;
	for (i=0; i<len; i++) {
		if (!(i & 15))
			printf("%04x:", i);
		printf(" %02x", buf[i]);
		if ((i & 15) == 15)
			putchar('\n');
	}
	if (len & 15)
		putchar('\n');
}

int main (void)
{
	unsigned char	tmp[131072];
	struct ifreq ifr;
	int tun_fd;
	int len;

	tun_fd = open("/dev/net/tun", O_RDWR);
	if (-1 == tun_fd) {
		perror("open(/dev/net/tun)");
		return 2;
	}

	memset(&ifr, 0, sizeof(ifr));
	strcpy(ifr.ifr_name, "tun0");
	ifr.ifr_flags = TUN_TAP_DEV;

	if (-1 == ioctl(tun_fd, TUNSETIFF, &ifr)) {
		perror("ioctl(TUNSETIFF)");
		return 2;
	}

	while ((len=read(tun_fd, tmp, sizeof(tmp))) > 0) {
		printf("got len=%d\n", len);
		dump_buf(tmp, len);
	}
	return 0;
}
